clear all
warning off;
tmp=load('apascal_train_data.mat');
attributes=[tmp.attributes ones(size(tmp.attributes,1),1)];
img_classes=tmp.img_classes;
tmp=load('feat_apascal_train_words.mat');
num_of_hist_boxes=7;%1;
feat0=tmp.feat;
num=1000+128+256;
factor=200;
feat=cell(7,3);
for i=1:7
    feat{i,1}=(round(feat0(1+(i-1)*num:(i-1)*num+1000,:)...
        ./repmat(eps+sum(feat0(1+(i-1)*num:(i-1)*num+1000,:)),[1000,1])*factor)).';
    feat{i,2}=(round(feat0(1001+(i-1)*num:(i-1)*num+1128,:)...
        ./repmat(eps+sum(feat0(1001+(i-1)*num:(i-1)*num+1128,:)),[128,1])*factor)).';
    feat{i,3}=(round(feat0(1129+(i-1)*num:(i-1)*num+num,:)...
        ./repmat(eps+sum(feat0(1129+(i-1)*num:(i-1)*num+num,:)),[256,1])*factor)).';
end
un=unique(img_classes);
VIndices=zeros(1,length(img_classes));
for i=1:length(un)
    VIndices(strcmp(un(i),img_classes))=i;
end

num_of_training_samples=size(feat,1);

num_of_categories=length(un);
num_of_hidden_variables=ones(3,7,3);%2000;%200;%20;
num_of_visible_variables=ones(1,7,3);
for i=1:7
    num_of_hidden_variables(1,i,1)=800;
    num_of_hidden_variables(1,i,2)=200;
    num_of_hidden_variables(1,i,3)=300;
% %     %%%%%%%%%%
    num_of_visible_variables(1,i,1)=1000;
    num_of_visible_variables(1,i,2)=128;
    num_of_visible_variables(1,i,3)=256;
end
num_of_hidden_variables(2,1,1)=4000;
num_of_hidden_variables(3,1,1)=2000;
num_of_layers=size(num_of_hidden_variables,1);%2;

aparm=1;%200
bparm=5;
cparm=20;
MiniBatchLen=500;
NContrastiveDivergence=2;%5;
num_iterations=[120 500 500];%[85 300 300];
kappa=0.5;
tau0=1024;
l2reg=[0.001 0.01 0.01];%0.01;
% l2reg=[0.001 0.05];%0.01;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tmp=load('apascal_train_data.mat');
img_classes=tmp.img_classes;
cnt=1;

un=unique(img_classes);
ind=cell(length(un),1);
for j=1:length(un)
    ind{j}=find(strcmp(un{j},img_classes));
    ind{j}=ind{j}(randperm(length(ind{j})));
end

i=1;
group_indices_train=[];
group_indices_test=[];
for j=1:length(un)
	len=length(ind{j});
    group_indices_train=[group_indices_train;ind{j}(setdiff(1:len,round(len*(i-1)*0.2)+1:round(len*i*0.2)))-1];
    group_indices_test=[group_indices_test;ind{j}(round(len*(i-1)*0.2)+1:round(len*i*0.2))-1];
end
labels_train=[];
labels_test=[];
for j=1:length(un)
    len=length(ind{j});
    labels_train=[labels_train ones(1,len-length(round(len*(i-1)*0.2)+1:round(len*i*0.2)))*j];
    labels_test=[labels_test ones(1,length(round(len*(i-1)*0.2)+1:round(len*i*0.2)))*j];
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Beta=cell(2,1);
W=cell(2,1);
b=cell(2,1);
c=cell(2,1);

tmp_feat=cell(7,3);
for i0=1:7
	tmp_feat{i0,1}=(round(feat0(1+(i0-1)*num:(i0-1)*num+1000,group_indices_train+1)...
            ./repmat(eps+sum(feat0(1+(i0-1)*num:(i0-1)*num+1000,group_indices_train+1)),[1000,1])*factor)).';
    tmp_feat{i0,2}=(round(feat0(1001+(i0-1)*num:(i0-1)*num+1128,group_indices_train+1)...
            ./repmat(eps+sum(feat0(1001+(i0-1)*num:(i0-1)*num+1128,group_indices_train+1)),[128,1])*factor)).';
    tmp_feat{i0,3}=(round(feat0(1129+(i0-1)*num:(i0-1)*num+num,group_indices_train+1)...
            ./repmat(eps+sum(feat0(1129+(i0-1)*num:(i0-1)*num+num,group_indices_train+1)),[256,1])*factor)).';
end
tmpVIndices=VIndices(group_indices_train+1);
[Beta{1},W{1},b{1},c{1}]=MatDBNY_Hierarchical_Topics0_101iid_GPU...
            (tmp_feat,tmpVIndices, num_of_hidden_variables, aparm, bparm, cparm, MiniBatchLen, NContrastiveDivergence,num_iterations,tau0,kappa,l2reg,num_of_hist_boxes);

save result_MatDBN_Topics0_101iid_CrossValidation_HiddenDeep9100_4levels_13.mat Beta W b c num_of_hist_boxes num_of_layers num_iterations l2reg group_indices_train group_indices_test labels_train labels_test
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[Beta{2},W{2},b{2},c{2}]=MatDBNY_Hierarchical_Topics0_101iid_GPU...
    (feat,VIndices, num_of_hidden_variables, aparm, bparm, cparm, MiniBatchLen, NContrastiveDivergence,num_iterations,tau0,kappa,l2reg,num_of_hist_boxes);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
save result_MatDBN_Topics0_101iid_CrossValidation_HiddenDeep9100_4levels_13.mat Beta W b c num_of_hist_boxes num_of_layers num_iterations l2reg group_indices_train group_indices_test labels_train labels_test
